import { PlaitBoard, PlaitElement, RectangleClient } from '@plait/core';
import { RenderComponentRef } from '../core/render-component';
import { CommonImageItem } from '../utils/image';
export interface PlaitImageBoard {
    renderImage: (container: Element | DocumentFragment, props: ImageProps) => ImageComponentRef;
}
export declare const withImage: <T extends PlaitBoard = PlaitBoard>(board: T) => T & PlaitImageBoard;
export type ImageComponentRef = RenderComponentRef<ImageProps>;
export interface ImageProps {
    board: PlaitBoard;
    imageItem: CommonImageItem;
    element: PlaitElement;
    isFocus?: boolean;
    getRectangle: () => RectangleClient;
}
